//! @file $RCSfile: runtime_calibration_lib.h,v $
//!
//! Copyright (c) 2004 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txtǂłB
//!
//! @brief ̧قCĳ ۸яp̐`łB
//!
//! ̐`̧ق͎pDoxygenɂĉ͂邱Ƃł܂B
//! Ȃ۸т̿ĳ\ł̧̂ق̋@\ɒuĂB
//!
//! @version $Revision: 1.1.1.1 $ $Name: First_Release $ $Id: runtime_calibration_lib.h,v 1.1.1.1 2006/07/27 09:39:53 gallain Exp $
//!
//! @todo
//! @bug

#ifndef _RUNTIME_CALIBRATION_LIB_H_
#define _RUNTIME_CALIBRATION_LIB_H_

//_____ ݸٰ ________________________________________________________________
#include "config.h"
#include "lib_mcu/timer/timer1_lib.h"
#if LIN_CONFIG == 1						// 1:]u, 0:呕u
#include "lib_mcu/lin_uart/slave_lin.h"
#endif

//_____ ϸ ____________________________________________________________________

#if LIN_BAUDRATE == 19200
#define EXPECTED_TBIT				833					// 呕uޯĎԁ~2
#define TBIT_DIFF_THRESHOLD_MAX		(signed int) 18
#define TBIT_DIFF_THRESHOLD_MIN		(signed int) -18
#elif  LIN_BAUDRATE == 9600
#define EXPECTED_TBIT				1667				// 呕uޯĎԁ~2
#define TBIT_DIFF_THRESHOLD_MAX		(signed int)  29
#define TBIT_DIFF_THRESHOLD_MIN		(signed int) -29
#elif  LIN_BAUDRATE == 2400
#define EXPECTED_TBIT				6667				// 呕uޯĎԁ~2
#define TBIT_DIFF_THRESHOLD_MAX		(signed int)  146
#define TBIT_DIFF_THRESHOLD_MIN		(signed int) -123
#else
#error "LIN BAUDRATE NOT SUPPORTED FOR RC OSC RT CALIBRATION"
#endif

//_____ 錾 ___________________________________________________________________

#ifdef _RUN_TIME_RC_CALIBRATION_ENABLE
extern volatile U8 osccal_start;
extern volatile U8 _lin_synchronized;	// LIN͎呕uƓ܂B
#endif

void Start_Capturing (void);
void Timer_stop_capture(void);

#endif
