//! @file $RCSfile: slave_lin.c,v $
//!
//! Copyright (c) 2004 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txtǂłB
//!
//! @brief ̧قCĳ ۸яp̐`łB
//!
//! ̐`̧ق͎pDoxygenɂĉ͂邱Ƃł܂B
//! Ȃ۸т̿ĳ\ł̧̂ق̋@\ɒuĂB
//!
//! @version $Revision: 1.1.1.1 $ $Name: First_Release $ $Id: slave_lin.c,v 1.1.1.1 2006/07/27 09:39:53 gallain Exp $
//!
//! @todo
//! @bug

//_____ ݸٰ ________________________________________________________________
#include "lib_mcu/lin_uart/slave_lin.h"

//_____ ϸ ____________________________________________________________________

//_____ ` ___________________________________________________________________

t_schedule my_schedule;			//!< ݂̌v
lin_status_t lin_status;		//!< LIN
st_lin_t msg_lin;				//!< LINүލ\
st_cmd_lin_t cmd_lin;			//!< LINߍ\
U8 tab_data[8];					//!< LINްɏՕ
signed char  _current_frame_index;	// ڰьQ݂̌ڰшʒu

#ifdef _SLEEP_TIMOUT_DETECTION
U8  LINSleepFlag;				// LINx~׸
U8  MyCpuIsSleepingFlag;		// MCUذߓ쒆׸
U8  NoBusActivityFlag;			// (2500ޯĎ)޽Ȃ׸
U16 SleepCtr;					// x~Ԓߌv
#endif

#ifdef _COUNTING_ERRORS_ENABLE
U16 countCERR;					// ьv
U16 countRERR;					// ]uُv(呕û)
U16 countBERR;					// ޯĈُv
U16 countSERR;					// ُv평
U16 countPERR;					// èv
#endif

#ifdef _RUN_TIME_RC_CALIBRATION_ENABLE
volatile U8 Timer_IC_cnt;
volatile U8 osccal_start;
volatile U8 _lin_synchronized;	// LIN͎呕uƓ܂B(1=2%)
#endif

//_____ 錾 ___________________________________________________________________

//! ASCIIɕϊ֐(\pɗLp!)
//!
//! @warning :
//!
//! @param	integer	ϊ镶(8ޯ)
//!
//! @return	ΉASCII޲
//!  
char int2hex(unsigned char integer) {
  if(integer < 10)  {							// 10ŁA
	return integer+ASCII_NUM_OFFSET;			// ΉASCIIƋɕA
  }else{										// 10ȏŁA
	return integer+55;							// ΉASCII'A'`ƋɕA
  }
}

//! LINv敔vn
//!
//! @warning :
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!  
void LIN_TIMER_init (void){

  TIMSK1  |= 1 << TOIE1;						// /1ꊄ荞݋
  TCCR1A  = 0x00;								// Ww
  TCCR1B  = 1<<CS10;							// OuȂŎn
  TCNT1H = _8MHZ_TCNT1H;						// ޯĎԂɑΉlŏ
  TCNT1L = _8MHZ_TCNT1L;

  StartLinSlave();								// LINVڰюMJn
}

//! LIN]uv敔(v=1LIN Tޯ)
//!
//! @warning :
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
U8 l_sch_tick (void) {
  U8     frame_type;

#ifdef _SLEEP_TIMOUT_DETECTION
  if (SleepCtr < SLEEP_TIMOUT) {				// x~ڍsԒŁA
	SleepCtr ++ ;								// x~ڍsԒߌvis
  } else {										// x~ڍsԒ߂ŁA
	if(!LINSleepFlag) {							// LINx~Ԃł΂΁A
	  NoBusActivityFlag = 1;					// (2500ޯĎ)޽Ȃ׸ސݒ
	  Lin_cmd_gotosleep();						// LINԋ@\Ԕԍx~ɕύX
	}
  }
#endif

  lin_status = lin_getstatus(&cmd_lin);			// LINԎ擾
  if (lin_status == LIN_ACTION_ONGOING){		// LIN튈isԂŁA
	return 0;									// A
  } else if (lin_status == LIN_ID_RECEIVED) {	// ʎqMŁA
	frame_type = IdReceived_Notification((msg_lin.id) & 0x0F, id_to_dlc (msg_lin.id));	// ڰюʎ擾
	if (frame_type == REMOTE_LIN_FRAME_TYPE) {	// ]uMŁA
#ifdef _RUN_TIME_RC_CALIBRATION_ENABLE
	  if( _lin_synchronized) {					// LIN呕uƂ̓ŁA
#else
	  if(1) {
#endif
#ifdef _SLEEP_TIMOUT_DETECTION
		SleepCtr = 0;							// x~Ԓߌv평
#endif
		DataRequest_Notification();				// ް
		cmd_lin.cmd = LIN_CMD_S_TX;				// ]uMw
		lin_cmd(&cmd_lin);						// LINsJn
	  } //()
	} else if (frame_type == STANDART_LIN_FRAME_TYPE) {		// 呕uMŁA
#ifdef _SLEEP_TIMOUT_DETECTION
	  SleepCtr = 0;								// x~Ԓߌv평
#endif
	  cmd_lin.cmd = LIN_CMD_S_RX;				// ]uMw
	  lin_cmd(&cmd_lin);						// LINsJn
	}else if (frame_type ==UNKWNON_LIN_FRAME_TYPE ){		// mڰь`ŁA
	  _lin_state = STATE_CHECK_BREAK;			// fԂɕύX
	  Uart_set_baudrate(UART_BAUDRATE_SYNC);	// USARTްڰĂ𓯊pɕύX
	  StartLinSlave();							// LINVڰюMJn
	}
  } else if ((LIN_ACTION_COMPLETED == lin_status) &&  (LIN_CMD_S_TX == cmd_lin.cmd)) {	// ]uMŁA
	 StartLinSlave() ;							// LINVڰюMJn
  } else if ((LIN_ACTION_COMPLETED == lin_status) &&  (LIN_CMD_S_RX == cmd_lin.cmd)) {	// ]uMŁA
	DataReceived_Notification((msg_lin.id) & 0x0F ,id_to_dlc (msg_lin.id));		// Mް
  } else if (LIN_AVAILABLE == lin_status ) {											// LIN험pŁA
	StartLinSlave();							// LINVڰюMJn
  } else {																				// ُ픭ŁA
#ifdef _COUNTING_ERRORS_ENABLE
	update_error_counter(lin_status);			// ُvXV(is) (̏ꍇANo͎~߂ׂ)
#endif
	StartLinSlave();							// LINVڰюMJn
  }
  return 0;
}

//! LINʎqDLCϊ
//!
//! @warning :
//!
//! @param	lin_id	LINʎq
//!
//! @return	LINް
//!
  U8 id_to_dlc (U8 lin_id) {
	U8 lin_dlc = (lin_id & 0x30) >>4;			// ʎqDLCޯĂ̂ݒo
	if (lin_dlc < 2){							// DLC=00܂01ŁA
	  lin_dlc = 2;								// 2޲Ďw
	}else if (lin_dlc == 2){					// DLC=10ŁA
	  lin_dlc = 4;								// 4޲Ďw
	}else{										// DLC=11ŁA
	  lin_dlc = 8;								// 8޲Ďw
	}
	return lin_dlc;								// ޲ĐƋɕA
  }

//! MOɕKvްpɏՕLINpɏՕ֕
//!
//! @warning :
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
  void DataRequest_Notification(void) {
	t_schedule * pt_schedule;

	pt_schedule = &my_schedule;					// үލ\߲
	if (_current_frame_index>=0) {				// L擪ŁAް ޲ĕ
	  cmd_lin.pt_lin_msg->pt_data = pt_schedule->frame_message[_current_frame_index].frame_data;
	}
  }

//! ްMʒm: MްڰтƘAgްɏՕɕʂ܂B
//!
//! @warning :
//!
//! @param	ReceivedId		MLINʎq
//! @param	ReceivedSize	LINް
//!
//! @return	Ȃ
//!
void DataReceived_Notification(U8 ReceivedId,U8 ReceivedSize) {
  U8 u;
  t_schedule * pt_schedule;

  pt_schedule = &my_schedule;					// үލ\߲
  if(ReceivedId != 0xc) {
	if (_current_frame_index>=0) {				// x~ߎʎqȊOŁA
	  for (u=0;u<ReceivedSize;u++) {			// MްŊɏՕXV
		pt_schedule->frame_message[_current_frame_index].frame_data[u] = cmd_lin.pt_lin_msg->pt_data[u];
	  }
	}
  } else if (ReceivedId == 0x0C) {				// x~ߎʎqŁA
#ifdef _SLEEP_TIMOUT_DETECTION
	if (cmd_lin.pt_lin_msg->pt_data[0] == 0) {	// x~ߊm(ް擪޲=0)ŁA
	  LINSleepFlag =  1;						// LINx~׸ސݒ
	  Lin_cmd_gotosleep();						// LINx~׸ސݒ
	}
#endif
  }
}

//! LLINʎqMAǂ̓莯ʎqɊ֘Aڰт𒲂ׂ܂B
//!
//! @warning :
//!
//! @param	ReceivedId		MLINʎq
//! @param	ExpectedSize	\LINް
//!
//! @return	ʎq
//!			STANDARD_LIN_FRAME
//!			UNKNOWN_LIN_FRAME
//!
int IdReceived_Notification(U8 ReceivedId,U8 ExpectedSize) {
  U8 i;
  t_schedule * pt_schedule;

  pt_schedule = &my_schedule;					// үލ\߲
  if (ReceivedId != 0x0C) {						// x~ߎʎqȊOŁA
	for (i=0;i<pt_schedule->number_of_frame;i++) {	// ڰѐ
	  if ((ReceivedId == pt_schedule->frame_message[i].frame_id) && (ExpectedSize == pt_schedule->frame_message[i].frame_size)) {
		_current_frame_index = i;				// ʎqvŁA݂ڰтɐݒ
		return (pt_schedule->frame_message[i].frame_type);	// ڰюʂƋɕA
	  }
	}
  } else {										// x~ߎʎqŁA
	if (ExpectedSize == 8)						// x~ߊm(ް ޲Đ=8)ŁA
	  _current_frame_index = -1;				// ڰіݒ
	return  STANDART_LIN_FRAME_TYPE;			// 呕uMڰѕƋɕA
  }
  _current_frame_index = -1;					// ڰіݒ
  return UNKWNON_LIN_FRAME_TYPE;				// sv/ڰѕƋɕA
}

//! LINVڰюMJn
//!
//! @warning :
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!	
void StartLinSlave (void){
  cmd_lin.cmd = LIN_CMD_S_RX;					// ]uMw
  cmd_lin.pt_lin_msg = &msg_lin;				// ү ߲
  msg_lin.pt_data = &tab_data[0];				// ް ޯ̧ ߲
  msg_lin.id = 0;								// ʎq
  lin_cmd(&cmd_lin);							// LINsJn
}

//! ُvXV(is)
//!
//! @warning :
//!
//! @param	status	ُ׸(ޯĈُAьȂ)
//!
//! @return	Ȃ
//!	
#ifdef _COUNTING_ERRORS_ENABLE
void update_error_counter(U8 status){
  if ((status & LIN_ERROR_BIT)==LIN_ERROR_BIT){								// ޯČLŁA
	countBERR++;															// ޯĈُvis
  }else if ((status & LIN_ERROR_CSUM)==LIN_ERROR_CSUM){						// ьLŁA
	countCERR++;															// ьvis
  }else if ((status & LIN_ERROR_PARITY)==LIN_ERROR_PARITY){					// ʎqèLŁA
	countPERR++;															// ʎqèvis
  }else if ((status & LIN_ERROR_SYNCHRO)==LIN_ERROR_SYNCHRO){				// ُLŁA
	countSERR++;															// ُvis
  }else if ((status & LIN_ERROR_NO_RESPONDING)==LIN_ERROR_NO_RESPONDING){	// ُLŁA
	countRERR++;															// ُvis
  }
}
#endif
