/*
**
*******************************************************************************
**
**				Copyright (c) 2004 - Atmel Corporation
**				L
**
** 		: AVR LIN]u
** 		:
** 		: Pʎ(Tޯ)vZpߊl͊荞ٰ
** ړIΏ	: AVR ATmega48/88/168
** ߲	: IAR Embedded Workbench
**
** :		t:			:		:
** 1.0		2004N819	E.G.		쐬
** 1.1		2004N1119	E.G.		3RCZ((OSCCAL}vZꂽψ)
** 1.2		2004N1125	E.G.		V8.0 RCUp3iKƍU
** 1.3		2005N68	E.G.		gsAȂ
**
**  -
**
** ATMEL - 2004
** SĂ̿ĳ ۸т͂ǂ̎̕ۏ؂Ȃ'󂻂̂܂'Œ񋟂܂BATMEL
** ͂ǂ̖ړIɑ΂Ă񋟂ꂽޗ̓K錾܂BATMEL͑SĂ̈Î
** Iȕۏ؁A̖ړIA\ANQɑ΂K܂݁A񋟂ꂽĳ
** ɊւSĂ̕ۏ؂Əłf肵܂B@Ȃĳ ۸т̎gp
** ̌ʂAǂȊԐړI܂͌ʂƂċN鑹Q≽̑QATMEL͌
** ӔCȂł傤B
*******************************************************************************
**
*/
//
/*_____ ݸٰ _____________________________________________________________*/
#include "config.h"
#include "lib_mcu/lin_uart/slave_lin.h"
#include "lib_mcu/lin_uart/runtime_calibration_lib.h"

// LINsUZp3ƍU
// iK=16A2ڒiK=8A3ڂƍŏIiK=4
// ATmega48/88/168pV8.0 RCUOSCCAL=127/128ł̎g=f(OSCCAL)sAlɓ܂B

// gp: /1(16ޯ)+ߊl͕
// LINx: 19200ް
// юg: RCU 8MHz (3V,25)

/*_____ ` ________________________________________________________________*/

#ifdef _RUN_TIME_RC_CALIBRATION_ENABLE
extern volatile U8  Timer_IC_cnt;
extern volatile U8 _lin_synchronized;	// ݒ肳ĂꍇALIN͎呕uƓ܂(2%ȓ)
volatile U16 TimeStamp_IC1;
volatile U16 TimeStamp_IC2;
#endif

//**************************************************************************
// /1ߊl͊荞ݏٰ
// (ŏד̂߂)LIN呕uPʎ(Tޯ)ľvZɎgp܂B
//**************************************************************************
#pragma vector= TIMER1_CAPT_vect
__interrupt void TIMER1_CAPT_ISR (void){
#ifdef _RUN_TIME_RC_CALIBRATION_ENABLE
  U8 new_osccal;
  U8 osccal_prior_synchr;
  U16 measured_master_tbit;
  signed int tbit_diff;
  U8 osccal_step;

  //******************* (A) *******************//
  if (Timer_IC_cnt == 0) {
	TimeStamp_IC1 = ICR1;				// 1ڂ̓̈扺~[p(񑪒)
  } else if (Timer_IC_cnt == 1) {
	TimeStamp_IC2 = ICR1;				// 2ڂ̓̈扺~[p(񑪒)A2̎呕uTޯđ
	TCCR1B  = (1<<ICES1) | (1<<CS10);	// OuȂŁA̎Ԃ̏㏸[ŕߊl
	osccal_step = 16;
	measured_master_tbit = TimeStamp_IC2 - TimeStamp_IC1;
	tbit_diff = EXPECTED_TBIT - measured_master_tbit;
	osccal_prior_synchr = OSCCAL;

	// ͈͂
	if ((tbit_diff <= TBIT_DIFF_THRESHOLD_MAX) && (tbit_diff >= TBIT_DIFF_THRESHOLD_MIN)){
	  Timer_stop_capture();				// Z菇~
	  _lin_synchronized = 1;			// LIN]u͍␳ꂢ܂B
	}else{
	  // Ȃ΁}iKɂđ܂͌
	  _lin_synchronized = 0;
	  if (tbit_diff > 0) {
		new_osccal =  osccal_prior_synchr + osccal_step;
	  } else {
		new_osccal =  osccal_prior_synchr - osccal_step;
	  }

	  if (new_osccal<128 & osccal_prior_synchr>=128) {
		new_osccal = 128;				// ̈ł̉Oa
	  }

	  if (new_osccal>=128 & osccal_prior_synchr<128){
		new_osccal = 127;				// ̈ł̏㑤Oa
	  }
	  OSCCAL = new_osccal;				// Vg𓾂̂ɖ5s܂B
	}
	//******************* (A) *******************//

	//******************* 2(B) *******************//
  } else if (Timer_IC_cnt == 2) {
	TimeStamp_IC1 = ICR1;				// 2ڂ̓̈扺~[p(2ڑ)
  } else if (Timer_IC_cnt ==3) {
	TimeStamp_IC2 = ICR1;				// 3ڂ̓̈扺~[p(2ڑ)A2̎呕uTޯđ
	TCCR1B  &= ~(1<<ICES1);				// OuȂŁA̎Ԃ̉~[ŕߊl
	measured_master_tbit = TimeStamp_IC2 - TimeStamp_IC1;
	tbit_diff = EXPECTED_TBIT - measured_master_tbit;
	osccal_prior_synchr = OSCCAL;
	osccal_step = 8;

	// ͈͂
	if ((tbit_diff <= TBIT_DIFF_THRESHOLD_MAX) && (tbit_diff >= TBIT_DIFF_THRESHOLD_MIN)){
	  Timer_stop_capture();				// Z菇~
	  _lin_synchronized = 1;			// LIN]u͍␳ꂢ܂B
	}else{
	  // Ȃ΁}iKɂđ܂͌
	  _lin_synchronized = 0;
	  if (tbit_diff > 0) {
		new_osccal =  osccal_prior_synchr + osccal_step;
	  } else {
		new_osccal =  osccal_prior_synchr - osccal_step;
	  }
	  if (new_osccal<128 & osccal_prior_synchr>=128) {
		new_osccal = 128;				// ̈ł̉Oa
	  }

	  if (new_osccal>=128 & osccal_prior_synchr<128){
		new_osccal = 127;				// ̈ł̏㑤Oa
	  }
	  OSCCAL = new_osccal;				// Vg𓾂̂ɖ5s܂B
	}
	//******************* 2(B) *******************//

	//******************* 3(C) *******************//
  }else if (Timer_IC_cnt == 4) {
	TimeStamp_IC1 = ICR1;				// 4ڂ̓̈扺~[p(3ڂƍŌ̑)
  } else if (Timer_IC_cnt ==5) {
	TimeStamp_IC2 = ICR1;				// 5ڂ̓̈扺~[p(3ڂƍŌ̑)A2̎呕uTޯđ
	osccal_step = 4;
	measured_master_tbit = TimeStamp_IC2 - TimeStamp_IC1;
	tbit_diff = EXPECTED_TBIT - measured_master_tbit;
	osccal_prior_synchr = OSCCAL;

	// ͈͂
	if ((tbit_diff <= TBIT_DIFF_THRESHOLD_MAX) && (tbit_diff >= TBIT_DIFF_THRESHOLD_MIN)){
	  Timer_stop_capture();				// Z菇~
	  _lin_synchronized = 1;			// LIN]u͍␳ꂢ܂B
	}else{
	  // Ȃ΁}iKɂđ܂͌
	  _lin_synchronized = 0;
	  if (tbit_diff > 0) {
		new_osccal =  osccal_prior_synchr + osccal_step;
	  } else {
		new_osccal =  osccal_prior_synchr - osccal_step;
	  }
	  if (new_osccal<128 & osccal_prior_synchr>=128) {
		new_osccal = 128;				// ̈ł̉Oa
	  }
	  if (new_osccal>=128 & osccal_prior_synchr<128){
		new_osccal = 127;				// ̈ł̏㑤Oa
	  }
	  OSCCAL = new_osccal;				// Vg𓾂̂ɖ5s܂B

	  Timer_stop_capture();				// Z菇~
	  _lin_synchronized = 1;			// LIN]u͍␳ꂢ܂B
	}
  }
  //******************* 3(C) *******************//
  Timer_IC_cnt ++;
#endif
}
